#include <fcntl.h>
#include <io.h>
#include <bios.h>
#include <time.h>
#include <stdio.h>               
#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include <iostream.h>
#include <string.h>
#include <alloc.h>
#include <ctype.h>
#include "tui.h"

void help();
int killfont();
void putbios();
void quit();
void getargs(int argc, char ** argv);
void save();
void load();
void showcars();
void setfont(char *fname);
void findfile(char *retname);
void newfont();
void tools(int which);
int hasdata(int character);
int hurtfont();

void far *biosfont16;
void far *biosfont14;
void far *biosfont8;

char selection[256];

char filename[30];

unsigned char letter = 0;
void far *screen1, *screen2, *screen3; //wow, how bloated! :P
unsigned char table[260][9][17];
unsigned char buffer[9][17];
char scratch1[50];
int changed = 0;

int fontsize = 16;

int i, j, k;
unsigned char keyhit;

void main(int argc, char ** argv)
 {
strcpy(filename, "[untitled]");
getargs(argc, argv);
textmode(C4350);

biosfont16 = (char far *) farmalloc(16*256+20);
biosfont14 = (char far *) farmalloc(14*256+20);
biosfont8  = (char far *) farmalloc(8*256+20);



screen1 = (char far *) farmalloc(8000);
screen2 = (char far *) farmalloc(8000);
screen3 = (char far *) farmalloc(8000);

if (biosfont16 == NULL || biosfont14 == NULL || biosfont8 == NULL)
 {
 printf ("Hey what?  There doesn't appear to be enough memory!\n");
 exit(0);
 }
if (screen1 == NULL || screen2 == NULL || screen3 == NULL)
 {
 printf ("Hey what?  There doesn't appear to be enough memory!\n");
 exit(0);
 }


for (i = 0; i <= 8000; i = i + 2)
 pokeb(FP_SEG(screen2), FP_OFF(screen2) + i, '');
for (i = 1; i <= 8000; i = i + 2)
 pokeb(FP_SEG(screen2), FP_OFF(screen2) + i, 0+16*7+0);

init();
togglebit(0);
putbios();

for (k = 0; k < 256; k++)
 selection[k] = 0;

if (strcmp(filename, "[untitled]") == 0)
 {
  for (k = 0; k < 256; k++)
   {
    for (j = 1; j <= 16; j++)
	  for (i = 1; i <= 8; i++)
		table[k][i][j] = 0;
   }
 }




setcursorsize(32767);
for ( ; ; )
 {
 movedata(FP_SEG(screen2), FP_OFF(screen2), FP_SEG(screen1), FP_OFF(screen1), 8000);
 mousestat();
 box(10,4,20,5+fontsize,1,1,15,1, FP_SEG(screen1), FP_OFF(screen1));
 box(3,44,78,48,1,1,15,1, FP_SEG(screen1), FP_OFF(screen1));

 box(26,24,51,29, 1, 1, 15,1, FP_SEG(screen1), FP_OFF(screen1));
 print("FONT SIZE", -39, 25, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
 print("8*8     8*14     8*16", -39, 27, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
 print("[ ]     [ ]      [ ] ", -39, 28, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

 if (fontsize == 16)
   sprint(254, 46, 28, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));
 if (fontsize == 14)
   sprint(254, 37, 28, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));
 if (fontsize == 8)
   sprint(254, 29, 28, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));


 strcpy(scratch1, "CURRENT FONT: ");
 strcat(scratch1, filename);

if (changed == 1)
 print(scratch1, -39,2,15,4,0,FP_SEG(screen1), FP_OFF(screen1));
else
 print(scratch1, -39,2,15,1,0,FP_SEG(screen1), FP_OFF(screen1));

print("< NEW >    < SAVE >    < SAVE AS >    < LOAD >    < HELP >    < QUIT >", 0, 46, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));


box(59,24,77,29, 1, 1, 15,1, FP_SEG(screen1), FP_OFF(screen1));
print ("[SELECTIONS]", 62, 24, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));
print ("<SELECT ALL>", 62, 26, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));
print ("<DESELECT ALL>", 61, 27, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));
print ("<INVERT  SELECT>", 60, 28, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));

box(10,24,20,29, 1, 1, 15,1, FP_SEG(screen1), FP_OFF(screen1));
print ("[CHAR]", 12, 24, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));
itoa(letter, scratch1, 10);
strcat(scratch1, "  ( )");
if (letter != 0)
 scratch1[strlen(scratch1)-2] = letter;
print (scratch1, -15, 26, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));



 for (j = 1; j <= 16; j++)
	for (i = 1; i <= 8; i++)
	  {
		if (table[letter][i][j] != 0)
		  sprint(219, i +10, j+4, 15, 0, 0, FP_SEG(screen1), FP_OFF(screen1));
	  }



 keyhit = 0;
 if (kbhit())
   {
  	keyhit = getch();
  	clrkb();
   }




 if (keyhit == 80)
  setmousestat(xc, yc+1);

 if (keyhit == 72)
  setmousestat(xc, yc-1);

 if (keyhit == 75)
  setmousestat(xc-1, yc);

 if (keyhit == 77)
  setmousestat(xc+1, yc);

 if (keyhit == 32)
	lb = 1;
 if (keyhit == 8)
	rb = 1;




 if (keyhit == 'Q')
  letter++;

 if (keyhit == 'I')
  letter--;



 if (coords(11, 5, 18, fontsize+4, 1, 0))
	{
    for (i = 0; i < 256; i++)
      if (selection[i] || i == letter)
     	 table[i][xc-10][yc-4] = 1;
    changed = 1;
	}

 if (coords(11, 5, 18, fontsize+4, 0, 1))
	{
    for (i = 0; i < 256; i++)
      if (selection[i] || i == letter)
    	 table[i][xc-10][yc-4] = 0;
	  changed = 1;
	}

 if (coords(60, 5, 75, 20, 1, 0) )
	{
	 letter = (yc-5)*16 + (xc-60);
	}

 if (coords(60, 5, 75, 20, 0, 1) )
	{
    if (selection[(yc-5)*16 + (xc-60)] == 1)
      selection[(yc-5)*16 + (xc-60)] = 0;
    else
      selection[(yc-5)*16 + (xc-60)] = 1;
    delay(200);
  	}


 if (xc >= 11 && yc >= 5 && xc <= 18 && yc <= fontsize+4)
  {
  print ("X:  Y:  ", 11, 3, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));
  print (xc-10, 13, 3, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));
  print (yc-4, 17, 3, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));
  }

 if (xc >= 60 && yc >= 5 && xc <= 75 && yc <= 20)
  {
  print ("ASCII #:    ", 62, 3, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));
  print ((yc-5)*16 + (xc-60), 70, 3, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));
  }


 showcars();



//c621 (or 11) - 174



  if (coords(16,46,23,46, 1, 0))
	{
	 if (strcmp(filename, "[untitled]") == 0)
	  {
		movedata(FP_SEG(screen1), FP_OFF(screen1), FP_SEG(screen3), FP_OFF(screen3), 8000);
		box(8, 25-3, 72, 25+3, 0, 2, 15, 9, FP_SEG(screen3), FP_OFF(screen3));
		print("[ SAVE AS ]", -40, 25-3, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
		print("Enter file name (.dft) :", -40, 25-1, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
		print("           .dft", 33, 25, 15, 2, 0,FP_SEG(screen3), FP_OFF(screen3));
		movedata(FP_SEG(screen3), FP_OFF(screen3), 0xB800, 0, 8000);

		char newname[40];
		input(33, 25, 15, 2, 8, newname, 0);
		if (strlen(newname) != 0)
		  {
		  strcpy(filename, newname);
		  strcat(filename, ".dft");
		  save();
		  }

	  }
	 else
	  save();
	}



  if (coords(28,46,38,46, 1, 0))
	{
	 movedata(FP_SEG(screen1), FP_OFF(screen1), FP_SEG(screen3), FP_OFF(screen3), 8000);
	 box(8, 25-3, 72, 25+3, 0, 2, 15, 9, FP_SEG(screen3), FP_OFF(screen3));
	 print("[ SAVE AS ]", -40, 25-3, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
	 print("Enter file name (.dft) :", -40, 25-1, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
	 print("           .dft", 33, 25, 15, 2, 0,FP_SEG(screen3), FP_OFF(screen3));
	 movedata(FP_SEG(screen3), FP_OFF(screen3), 0xB800, 0, 8000);

	 char newname[40];
	 input(33, 25, 15, 2, 8, newname, 0);
	 if (strlen(newname) != 0)
		{
		strcpy(filename, newname);
		strcat(filename, ".dft");
		save();
		}
	}


  if (coords(43,46,50,46, 1, 0))
	{
	 if (changed == 1)
      {
      if (killfont())
        {
         strcpy(scratch1, filename);
         findfile(filename);
         if (strcmp(scratch1, filename) != 0 && strlen(filename) > 0)
   	     load();
         else
          strcpy(filename, scratch1);
        }
      }
    else
      {
     	 strcpy(scratch1, filename);
    	 findfile(filename);
	    if (strcmp(scratch1, filename) != 0 && strlen(filename) > 0)
   	 load();
      }
   delay(150);
  	}


  if (coords(5,46,11,46, 1, 0))
	{
     if (changed == 1)
      {
		if (killfont()) newfont();
		}
	 else
	  newfont();
	 delay(150);
	}


	if (coords(55,46,62,46, 1, 0))
	  help();


//FONT SIZE ALTERING

if (coords(29, 28, 1, 0))
 {
 if (hurtfont())
  {
   for (k = 0; k < 256; k++)
    for (j = 9; j <= 16; j++)
     for (i = 1; i <= 8; i++)
      table[k][i][j] = 0;
   fontsize = 8;
   changed = 1;
  }
 }

if (coords(37, 28, 1, 0))
 {
 if (hurtfont())
  {
   for (k = 0; k < 256; k++)
    for (j = 15; j <= 16; j++)
     for (i = 1; i <= 8; i++)
      table[k][i][j] = 0;
   fontsize = 14;
   changed = 1;
  }
 }

if (coords(46, 28, 1, 0))
 {
 if (hurtfont())
  {
  fontsize = 16;
  changed = 1;
  }
 }


  if (coords(67,46,74,46, 1, 0))
	{
	 if (changed == 1)
		{
		if (killfont()) quit();
		}
	 else
		quit();
	}

 if (coords(62,26,73,26,1,0))
   {
    for (int gg = 0; gg < 256; gg++)
      selection[gg] = 1;
   }
 if (coords(61,27,74,27,1,0))
   {
    for (int gg = 0; gg < 256; gg++)
      selection[gg] = 0;
   }
 if (coords(60,28,75,28,1,0))
   {
    for (int gg = 0; gg < 256; gg++)
      if (selection[gg] == 1)
        selection[gg] = 0;
      else
        selection[gg] = 1;
    delay(150);      
   }




  print (xc, 1, 1, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));
  print (yc, 4, 1, 15, 1, 0, FP_SEG(screen1), FP_OFF(screen1));

 sprint(peekb(FP_SEG(screen1), FP_OFF(screen1) + (yc-1) * 160 + (xc-1) * 2), xc, yc, 0, 15, 0, FP_SEG(screen1), FP_OFF(screen1));






 movedata(FP_SEG(screen1), FP_OFF(screen1), 0xB800, 0, 8000);

 }


 }




void quit()
{
farfree(screen1);
farfree(screen2);
farfree(screen3);
farfree(biosfont16);
farfree(biosfont14);
farfree(biosfont8);
setcursorsize(772);
asm {
	  MOV AX, 3;
     INT 0x10;
	 }
exit(0);


}


void showcars()
{
int x=0, y=0, c;
int xoff = 60, yoff = 5;

box(xoff-1,yoff-1,xoff+17,yoff+16,1,1,15,1, FP_SEG(screen1), FP_OFF(screen1));
print("[DOS CHAR SET]", xoff+1, yoff-1, 15, 1,0,FP_SEG(screen1), FP_OFF(screen1));
  for (c = 0; c < 256; c++)
	 {
	 sprint(c,x+xoff, y+yoff, 15, 8, 0,FP_SEG(screen1), FP_OFF(screen1));
	 if (!hasdata(c))
	  sprint(c,x+xoff, y+yoff, 7, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
    if (selection[c] == 1)
	  sprint(c,x+xoff, y+yoff, 1, 11, 0,FP_SEG(screen1), FP_OFF(screen1));
	 if (c == letter)
     sprint(c,x+xoff, y+yoff, 0, 2, 0,FP_SEG(screen1), FP_OFF(screen1));

	 x++;
	 if (x == 16) { x = 0; y++; }
	 }


box(26,4,51,21, 1, 1, 15,1, FP_SEG(screen1), FP_OFF(screen1));

sprint(194, 34, 4, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(193, 34, 21, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
for (c = 5; c <= 20; c++)
  sprint(179, 34, c, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(195, 26, 7, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(195, 26, 10, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(195, 26, 13, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(195, 26, 16, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(195, 26, 19, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

sprint(180, 50, 7, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(180, 50, 10, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(180, 50, 13, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(180, 50, 16, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(180, 50, 19, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

for (c = 27; c <= 49; c++)
  {
  sprint(196, c, 7, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
  sprint(196, c, 10, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
  sprint(196, c, 13, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
  sprint(196, c, 16, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
  sprint(196, c, 19, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
  }
//186
sprint(197, 34, 7, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(197, 34, 10, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(197, 34, 13, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(197, 34, 16, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(197, 34, 19, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

for (c = 5; c <= 20; c++)
 sprint(179, 42, c, 15, 1,0,FP_SEG(screen1), FP_OFF(screen1));

sprint(197, 42, 7, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(197, 42, 10, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(197, 42, 13, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(197, 42, 16, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(197, 42, 19, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

sprint(193, 42, 21, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint(194, 42, 4, 15, 1, 0,FP_SEG(screen1), FP_OFF(screen1));



if (xc >= 27 && yc >= 5 && xc <= 33 && yc <= 6)
 box(27, 5, 34, 6, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 35 && yc >= 5 && xc <= 41 && yc <= 6)
 box(35, 5, 42, 6, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 27 && yc >= 8 && xc <= 33 && yc <= 9)
 box(27, 8, 34, 9, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 35 && yc >= 8 && xc <= 41 && yc <= 9)
 box(35, 8, 42, 9, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 27 && yc >= 11 && xc <= 33 && yc <= 12)
 box(27, 11, 34, 12, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 35 && yc >= 11 && xc <= 41 && yc <= 12)
 box(35, 11, 42, 12, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 27 && yc >= 14 && xc <= 33 && yc <= 15)
 box(27, 14, 34, 15, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 35 && yc >= 14 && xc <= 41 && yc <= 15)
 box(35, 14, 42, 15, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 27 && yc >= 17 && xc <= 33 && yc <= 18)
 box(27, 17, 34, 18, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 35 && yc >= 17 && xc <= 41 && yc <= 18)
 box(35, 17, 42, 18, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 27 && yc >= 20 && xc <= 33 && yc <= 20)
 box(27, 20, 34, 20, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 35 && yc >= 20 && xc <= 41 && yc <= 20)
 box(35, 20, 42, 20, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 43 && yc >= 5 && xc <= 49 && yc <= 6)
 box(43, 5, 50, 6, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 43 && yc >= 8 && xc <= 49 && yc <= 9)
 box(43, 8, 50, 9, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 43 && yc >= 11 && xc <= 49 && yc <= 12)
 box(43, 11, 50, 12, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 43 && yc >= 14 && xc <= 49 && yc <= 15)
 box(43, 14, 50, 15, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 43 && yc >= 17 && xc <= 49 && yc <= 18)
 box(43, 17, 50, 18, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));
if (xc >= 43 && yc >= 20 && xc <= 49 && yc <= 20)
 box(43, 20, 50, 20, 0, 0, 15, 2, FP_SEG(screen1), FP_OFF(screen1));





sprint(27, 29, 5, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint('A', 31, 5, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("SHIFT", 28, 6, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

sprint(26, 39, 5, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint('A', 37, 5, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("SHIFT", 36, 6, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

sprint(24, 29, 8, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint('A', 31, 8, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("SHIFT", 28, 9, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

sprint(25, 39, 8, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint('A', 37, 8, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("SHIFT", 36, 9, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));


sprint(18, 29, 11, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint('A', 31, 11, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("FLIP", 28, 12, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

sprint(29, 39, 11, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
sprint('A', 37, 11, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("FLIP", 36, 12, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

print("CLEAR", 28, 14, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("CHAR", 28, 15, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

print("FILL", 36, 14, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("CHAR", 36, 15, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

print("BIOS ->", 43, 5, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("CHAR", 45, 6, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

print("BIOS ->", 43, 8, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("FONT", 45, 9, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

print("BIOS ->", 43, 11, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("EMPTY", 45, 12, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));



print("COPY", 28, 20, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

print("PST ALL", 35, 20, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

print("PST OVR", 43, 20, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

print("INVERT", 27, 17, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("  CHAR", 27, 18, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));

print(" UPPER", 35, 17, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("2 LOWER", 35, 18, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));


print(" LOWER", 43, 17, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("2 UPPER", 43, 18, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));


print(" SEE  ", 43, 14, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));
print("  SET ", 43, 15, -1, 1, 0,FP_SEG(screen1), FP_OFF(screen1));




//highlight
//mousestat();


if (coords(27,5,33,6,1,0))
  {
  tools(1);    //left shift
  delay(100);
  }


if (coords(35,5,41,6,1,0))
  {
  tools(2);   //right shift
  delay(100);
  }

if (coords(27,8,33,9,1,0))
  {
  tools(3);   //up shift
  delay(100);
  }


if (coords(35,8,41,9,1,0))
  {
  tools(4);  //down shift
  delay(100);
  }



if (coords(27,11,33,12,1,0))
  {
  tools(5);  //hor flip
  delay(100);
  }


if (coords(35,11,41,12,1,0))
  {
  tools(6);  //vert flip
  delay(100);
  }



if (coords(27,14,33,15,1,0))
  {
  tools(7); //clear char
  delay(100);
  }



if (coords(35,14,41,15,1,0))
  {
  tools(8); //fill char
  delay(100);
  }


if (coords(27,17,33,18,1,0))
  {         //invert
  tools(13);
  delay(100);
  }




 if (coords(35,17,41,18,1,0))
  {
  tools(17);  //upper to lower
  delay(100);
  }



if (coords(27,20,33,20,1,0))
  {
  tools(11);
  delay(100);
  }



if (coords(35,20,41,20,1,0))
  {
  tools(12);
  delay(100);
  }


 if (coords(43,5,49,6,1,0))
  {
  tools(9);  //bios2char
  delay(100);
  }


if (coords(43,8,49,9,1,0))
  {
  tools(10);  //bios2font
  delay(100);
  }




 if (coords(43,11,49,12,1,0))
  {
  tools(16);  //bios2empty
  delay(100);
  }


 if (coords(43,14,49,15,1,0))
  {
  tools(15);  //seeset
  delay(100);
  }




 if (coords(43,17,49,18,1,0))
  {
  tools(18);  //lower to upper
  delay(100);
  }


if (coords(43,20,49,20,1,0))
  {         //paste over
  tools(14);
  delay(100);
  }





//mousestat();



}


void save()
{

unsigned char byte;
int l, o, p;

FILE *fp;

if ((fp = fopen(filename, "wb")) == NULL)
 {
 for (; ;)
 {
  mousestat();
   keyhit = 0;
 if (kbhit())
  {
	keyhit = getch();
	clrkb();
  }

 if (keyhit == 27) quit();

 if (keyhit == 80)
  setmousestat(xc, yc+1);

 if (keyhit == 72)
  setmousestat(xc, yc-1);

 if (keyhit == 75)
  setmousestat(xc-1, yc);

 if (keyhit == 77)
  setmousestat(xc+1, yc);

 if (keyhit == 32)
	lb = 1;
 if (keyhit == 8)
	rb = 1;

  movedata(FP_SEG(screen1), FP_OFF(screen1), FP_SEG(screen3), FP_OFF(screen3), 8000);
  box(8, 25-3, 72, 25+3, 0, 2, 15, 4, FP_SEG(screen3), FP_OFF(screen3));
  print("[ SAVING ERROR ]", -40, 25-3, 15, 4, 0,FP_SEG(screen3), FP_OFF(screen3));
  print(filename, -40, 25-1, 15, 4, 0,FP_SEG(screen3), FP_OFF(screen3));
  print("is an invalid filename!", -40, 25, 15, 4, 0,FP_SEG(screen3), FP_OFF(screen3));
  print("           <OKAY>        ", 26, 25+2, 15, 4, 0,FP_SEG(screen3), FP_OFF(screen3));
  sprint(peekb(FP_SEG(screen3), FP_OFF(screen3) + (yc-1) * 160 + (xc-1) * 2), xc, yc, 0, 15, 0, FP_SEG(screen3), FP_OFF(screen3));
  movedata(FP_SEG(screen3), FP_OFF(screen3), 0xB800, 0, 8000);
  if (coords(37,27,42,27,1,0))
		goto damned;
  }
 }

for (p = 0; p <= 255; p++)
{
 for (o = 1; o <= fontsize; o++)
  {
	byte = 0;
	for (l = 1; l <= 8; l++)
	  {
		if (table[p][l][o] == 1 && l == 1) byte = byte + 128;
		if (table[p][l][o] == 1 && l == 2) byte = byte + 64;
		if (table[p][l][o] == 1 && l == 3) byte = byte + 32;
		if (table[p][l][o] == 1 && l == 4) byte = byte + 16;
		if (table[p][l][o] == 1 && l == 5) byte = byte + 8;
		if (table[p][l][o] == 1 && l == 6) byte = byte + 4;
		if (table[p][l][o] == 1 && l == 7) byte = byte + 2;
		if (table[p][l][o] == 1 && l == 8) byte = byte + 1;

	  }
	 fprintf (fp, "%c", byte);
	}
  }

fclose(fp);
changed=0;
damned:
}





void load()
{
changed = 0;
unsigned char byte;
int l, o, p;
 for (k = 0; k < 256; k++)
  {

  for (j = 1; j <= 16; j++)
	for (i = 1; i <= 8; i++)
	 table[k][i][j] = 0;
  }

FILE *fp;

fp = fopen(filename, "rb");

fontsize = 0;
for ( ; ; )
 {
  fscanf (fp, "%c", &byte);
  if (feof(fp)) break;
  fontsize++;
 }
fclose(fp);
fp = fopen(filename, "rb");

if (fontsize == 16*256) fontsize = 16;
if (fontsize == 14*256) fontsize = 14;
if (fontsize == 8*256) fontsize = 8;

for (p = 0; p <= 255; p++)
{
 for (o = 1; o <= fontsize; o++)
  {
	fscanf (fp, "%c", &byte);
	for (l = 1; l <= 8; l++)
	  {
		if (l == 1)
			if (byte >= 128) { table[p][l][o] = 1; byte-=128; }
		if (l == 2)
			if (byte >= 64) { table[p][l][o] = 1; byte-=64; }
		if (l == 3)
			if (byte >= 32) { table[p][l][o] = 1; byte-=32; }
		if (l == 4)
			if (byte >= 16) { table[p][l][o] = 1; byte-=16; }
		if (l == 5)
			if (byte >= 8) { table[p][l][o] = 1; byte-=8; }
		if (l == 6)
			if (byte >= 4) { table[p][l][o] = 1; byte-=4; }
		if (l == 7)
			if (byte >= 2) { table[p][l][o] = 1; byte-=2; }
		if (l == 8)
			if (byte >= 1) { table[p][l][o] = 1; byte-=1; }

	  }
	  }
   }

fclose(fp);
}

void setfont(char *fname)
{
void far *newfont;
newfont = (char far *)farmalloc(4096);


unsigned short int myax = 17*256;
unsigned short int myes = FP_SEG(newfont);
unsigned short int mybp = FP_OFF(newfont);
unsigned short int mybx;

for (mybx = 0; mybx < 4096; mybx++)
  pokeb(FP_SEG(newfont),FP_OFF(newfont)+mybx, 0);

  asm {
      MOV BH, 16;
      MOV AX, myax;
		MOV BL, 0;
      MOV CX, 0xFF;
		MOV ES, myes;
      MOV DX, mybp;
		PUSH BP;
		MOV BP, DX;
  		MOV DX, 0;
		INT 0x10;
		POP BP;
	    }



FILE *fp;
if ((fp = fopen(fname, "rb")) == NULL)
 {
  printf ("File not found\n");
  exit(1);
 }

unsigned char temp;

mybx = 0;
for ( ; ; )
{
 fscanf(fp, "%c", &temp);
 if (feof(fp)) break;
 pokeb(FP_SEG(newfont), FP_OFF(newfont)+mybx, temp);
 mybx++;
}


  asm {
      MOV AX, myax;
      MOV BX, mybx;
		MOV CX, 0xFF;
		MOV ES, myes;
      MOV DX, mybp;
		PUSH BP;
		MOV BP, DX;
  		MOV DX, 0;
		INT 0x10;
		POP BP;
      }


farfree(newfont);
}





void getargs(int argc, char ** argv)
{
//int argc, char ** argv


for (i = 1; i < argc; i++)
 {
 if (strcmp(argv[i], "/?") == 0)
  {
	printf ("\n\n\n");
	printf ("DOS FONT EDIT  :  COMMAND LINE OPTIONS\n\n");
	printf ("/l:filename    :  Run DOSFEDIT and open filename\n");
	printf ("/t:filename    :  Test the font out\n");
	printf ("/r             :  Reset font to normal\n");
	printf ("\n\n");
	exit(0);
  }

 if (strcmp("/r", argv[i]) == 0)
		{
		 asm {
				MOV AX, 3;
				INT 0x10;
           }
      exit(0);
		}
  if (strin(argv[i], "/t:"))
	  {
       strcpy(filename, argv[i]);
		 if (strlen(filename) == 3)
         exit(1);
		 for (k = 0; k < strlen(filename); k++)
			filename[k] = filename[k+1];
		 for (k = 0; k < strlen(filename); k++)
			filename[k] = filename[k+1];
		 for (k = 0; k < strlen(filename); k++)
			filename[k] = filename[k+1];
		if (strin(filename, ".") == 0)
			{
			strcat(filename, ".dft");
			}
		setfont(filename);
		exit(0);
	  }

  if (strin(argv[i], "/l:"))
	  {
		 strcpy(filename, argv[i]);
		 if (strlen(filename) == 3)
			exit(1);
		 for (k = 0; k < strlen(filename); k++)
			filename[k] = filename[k+1];
		 for (k = 0; k < strlen(filename); k++)
			filename[k] = filename[k+1];
		 for (k = 0; k < strlen(filename); k++)
			filename[k] = filename[k+1];
		if (strin(filename, ".") == 0)
			{
			strcat(filename, ".dft");
			}
		load();
	  }


 }


}


//192 till 223




void findfile(char *retname)
{
char files[105][15];
int numfile = 0;
int offfil = 0;
int l;
char scratch[60];

system("DIR *.dft /B >files.txt");

FILE *temp;
temp = fopen("files.txt", "r");

for (l = 1; l <= 100; l++)
 {
  if (feof(temp)) break;
  numfile++;
  fscanf (temp, "%s", files[numfile]);
  files[l+offfil][strlen(files[l+offfil])-4] = '\0';
 }
if (numfile == 1 && strlen(files[1]) == 0)
 {
 strcpy(retname, "");
 goto ahhh;
 }
if (numfile == 0)
 {
 strcpy(retname, "");
 goto ahhh;
 }


fclose(temp);



for ( ; ; )
{
movedata (FP_SEG(screen1), FP_OFF(screen1), FP_SEG(screen3), FP_OFF(screen3), 8000);
mousestat();
 keyhit = 0;
 if (kbhit())
  {
	keyhit = getch();
	clrkb();
  }

 if (keyhit == 27) quit();

 if (keyhit == 80)
  setmousestat(xc, yc+1);

 if (keyhit == 72)
  setmousestat(xc, yc-1);

 if (keyhit == 75)
  setmousestat(xc-1, yc);

 if (keyhit == 77)
  setmousestat(xc+1, yc);

 if (keyhit == 32)
	lb = 1;
 if (keyhit == 8)
	rb = 1;

box(22, 25-6, 58, 25+6, 0, 2, 15, 9, FP_SEG(screen3), FP_OFF(screen3));
box(40-5, 25-4, 40+5, 25+4, 0, 1, 15, 9, FP_SEG(screen3), FP_OFF(screen3));
print("[ OPEN FONT ]", -40, 25-6, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
sprint (24, 45, 25-3, 15, 9, 0, FP_SEG(screen3), FP_OFF(screen3));
sprint (25, 45, 25+3, 15, 9, 0, FP_SEG(screen3), FP_OFF(screen3));

print ("<OPEN>", 48, 25, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
print ("<CANCEL>", 25, 25, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));

for (l = 1; l<=7; l++)
 {
 if (l+offfil > numfile-1) break;
 strcpy(scratch, files[l+offfil]);
 if (l == 1) print (scratch, 36, 21+l, 15, 7, 0, FP_SEG(screen3), FP_OFF(screen3));
 else print (scratch, 36, 21+l, 15, 9, 0, FP_SEG(screen3), FP_OFF(screen3));

 }

 if (coords(45, 25-3, 1, 0))
  {
  offfil--;
  if (offfil < 0) offfil = 0;
  delay(100);
 }
if (coords(45, 25+3, 1, 0))
 {
  offfil++;
  if (offfil > numfile-2) offfil--;
  delay(100);
 }

if (coords(25, 25, 32, 25, 1, 0))
 {
  break;
 }


if (coords(48, 25, 53, 25, 1, 0))
 {
  strcat(files[1+offfil], ".dft");
  strcpy(retname, files[1+offfil]);
  break;
 }

 sprint(peekb(FP_SEG(screen3), FP_OFF(screen3) + (yc-1) * 160 + (xc-1) * 2), xc, yc, 0, 15, 0, FP_SEG(screen3), FP_OFF(screen3));
 movedata (FP_SEG(screen3), FP_OFF(screen3),0xB800, 0,  8000);

}
ahhh:
}


void newfont()
 {
changed = 1;
 strcpy(filename, "[untitled]");
 for (k = 0; k < 256; k++)
  {

  for (j = 1; j <= 16; j++)
	for (i = 1; i <= 8; i++)
	 table[k][i][j] = 0;
  }


}



void tools(int which)
{
if (which != 15) changed = 1;
int ii, jj, d;
int let;
unsigned char tempfont[10][20];


if (which == 2) //move left
 {
  for (let = 0; let < 256; let++)
   {
    if (selection[let] || (let == letter))
     {
      for (jj = 1; jj <= fontsize; jj++)
       for (ii = 1; ii <= 8; ii++)
        {
	      d = ii + 1;
         if (d >= 9) d = 1;
         tempfont[d][jj] = table[let][ii][jj];
        }
      for (jj = 1; jj <= fontsize; jj++)
        for (ii = 1; ii <= 8; ii++)
          table[let][ii][jj] = tempfont[ii][jj];
     }
   }
 }



if (which == 1) //move right
 {
  for (let = 0; let < 256; let++)
   {
    if (selection[let] || (let == letter))
     {
      for (jj = 1; jj <= fontsize; jj++)
	    for (ii = 1; ii <= 8; ii++)
         {
	       d = ii - 1;
          if (d < 1) d = 8;
          tempfont[d][jj] = table[let][ii][jj];
         }
      for (jj = 1; jj <= fontsize; jj++)
       for (ii = 1; ii <= 8; ii++)
         table[let][ii][jj] = tempfont[ii][jj];
     }
   }
 }


if (which == 4)
 {
  for (let = 0; let < 256; let++)
   {
    if (selection[let] || (let == letter))
     {
      for (jj = 1; jj <= fontsize; jj++)
       for (ii = 1; ii <= 8; ii++)
        {
         d = jj + 1;
         if (fontsize == 16)
           if (d >= 17) d = 1;
         if (fontsize == 14)
           if (d >= 15) d = 1;
         if (fontsize == 8)
           if (d >= 9) d = 1;
         tempfont[ii][d] = table[let][ii][jj];
        }
      for (jj = 1; jj <= fontsize; jj++)
       for (ii = 1; ii <= 8; ii++)
        table[let][ii][jj] = tempfont[ii][jj];
     }
   }
 }


if (which == 3)
 {
  for (let = 0; let < 256; let++)
   {
    if (selection[let] || (let == letter))
     {
      for (jj = 1; jj <= fontsize; jj++)
       for (ii = 1; ii <= 8; ii++)
        {
         d = jj - 1;
         if (fontsize == 16)
          if (d < 1) d = 16;
         if (fontsize == 14)
          if (d < 1) d = 14;
         if (fontsize == 8)
          if (d < 1) d = 8;
	      tempfont[ii][d] = table[let][ii][jj];
        }
      for (jj = 1; jj <= fontsize; jj++)
       for (ii = 1; ii <= 8; ii++)
        table[let][ii][jj] = tempfont[ii][jj];
     }
   }
 }


if (which == 6)
 {
  for (let = 0; let < 256; let++)
   {
    if (selection[let] || (let == letter))
     {
     for (jj = 1; jj <= fontsize; jj++)
    	for (ii = 1; ii <= 8; ii++)
	    tempfont[9 - ii][jj] = table[let][ii][jj];
     for (jj = 1; jj <= fontsize; jj++)
      for (ii = 1; ii <= 8; ii++)
       table[let][ii][jj] = tempfont[ii][jj];
     }
   }
 }

if (which == 5)
 {
  for (let = 0; let < 256; let++)
   {
    if (selection[let] || (let == letter))
     {
      for (jj = 1; jj <= fontsize; jj++)
       for (ii = 1; ii <= 8; ii++)
	     tempfont[ii][fontsize+1-jj] = table[let][ii][jj];
      for (jj = 1; jj <= fontsize; jj++)
       for (ii = 1; ii <= 8; ii++)
         table[let][ii][jj] = tempfont[ii][jj];
     }
   }
 }



if (which == 7)
 {
  for (let = 0; let < 256; let++)
   {
    if (selection[let] || (let == letter))
     {
      for (jj = 1; jj <= fontsize; jj++)
       for (ii = 1; ii <= 8; ii++)
        table[let][ii][jj] = 0;
     }
   }
 }



if (which == 8)
 {
  for (let = 0; let < 256; let++)
   {
    if (selection[let] || (let == letter))
     {
      for (jj = 1; jj <= fontsize; jj++)
       for (ii = 1; ii <= 8; ii++)
        table[let][ii][jj] = 1;
     }
   }
 }



if (which == 9)
 {
  int ii, jj;
  unsigned char bits;
  int s;

  for (let = 0; let < 256; let++)
   {
    if (selection[let] || (let == letter))
     {
      for (jj = 1; jj <= fontsize; jj++)
        for (ii = 1; ii <= 8; ii++)
          table[let][ii][jj] = 0;
      for (s = 0; s <= fontsize-1; s++)
       {
        if (fontsize == 16) bits = peekb(FP_SEG(biosfont16), FP_OFF(biosfont16) + fontsize * let + s);
        if (fontsize == 14) bits = peekb(FP_SEG(biosfont14), FP_OFF(biosfont14) + fontsize * let + s);
        if (fontsize == 8)  bits = peekb(FP_SEG(biosfont8), FP_OFF(biosfont8) + fontsize * let + s);
        if (bits & 1) table[let][8][s+1] = 1;
        if (bits & 2) table[let][7][s+1] = 1;
        if (bits & 4) table[let][6][s+1] = 1;
        if (bits & 8) table[let][5][s+1] = 1;
        if (bits & 16) table[let][4][s+1] = 1;
        if (bits & 32) table[let][3][s+1] = 1;
        if (bits & 64) table[let][2][s+1] = 1;
        if (bits & 128) table[let][1][s+1] = 1;
       }
     }
   }
 }



if (which == 10)
 {
  unsigned char bits;
  int s, q;
  int ii, jj;

 for (q = 0; q < 256; q++)
 {
  for (jj = 1; jj <= fontsize; jj++)
	for (ii = 1; ii <= 8; ii++)
	  table[q][ii][jj] = 0;

  for (s = 0; s <= fontsize-1; s++)
	{

    if (fontsize == 16)
      bits = peekb(FP_SEG(biosfont16), FP_OFF(biosfont16) + fontsize * q + s);
    if (fontsize == 14)
      bits = peekb(FP_SEG(biosfont14), FP_OFF(biosfont14) + fontsize * q + s);
    if (fontsize == 8)
      bits = peekb(FP_SEG(biosfont8), FP_OFF(biosfont8) + fontsize * q + s);
	 if (bits & 1) table[q][8][s+1] = 1;
	 if (bits & 2) table[q][7][s+1] = 1;
	 if (bits & 4) table[q][6][s+1] = 1;
	 if (bits & 8) table[q][5][s+1] = 1;
	 if (bits & 16) table[q][4][s+1] = 1;
	 if (bits & 32) table[q][3][s+1] = 1;
	 if (bits & 64) table[q][2][s+1] = 1;
	 if (bits & 128) table[q][1][s+1] = 1;
	}

 }
 }

if (which == 11)
 {
 for (jj = 1; jj <= fontsize; jj++)
	for (ii = 1; ii <= 8; ii++)
	 buffer[ii][jj] = table[letter][ii][jj];

 }

if (which == 12)
 {
  for (let = 0; let < 256; let++)
   {
    if (selection[let] || (let == letter))
     {
      for (jj = 1; jj <= fontsize; jj++)
     	 for (ii = 1; ii <= 8; ii++)
	     table[let][ii][jj] = buffer[ii][jj];
     }
   }
 }

if (which == 14)
 {
  for (let = 0; let < 256; let++)
   {
    if (selection[let] || (let == letter))
     {
      for (jj = 1; jj <= fontsize; jj++)
       for (ii = 1; ii <= 8; ii++)
        if (buffer[ii][jj] == 1)
         table[let][ii][jj] = buffer[ii][jj];
     }
   }
 }


if (which == 13)
 {
  for (let = 0; let < 256; let++)
   {
    if (selection[let] || (let == letter))
     {
      for (jj = 1; jj <= fontsize; jj++)
       for (ii = 1; ii <= 8; ii++)
	     if (table[let][ii][jj] == 1) table[let][ii][jj] = 0;
         else table[let][ii][jj] = 1;
     }
   }
 }

if (which == 15)
 {
if (changed == 1 || strcmp(filename, "[untitled]") == 0)
{
 for (; ;)
 {
  mousestat();
	keyhit = 0;
 if (kbhit())
  {
	keyhit = getch();
	clrkb();
  }

 if (keyhit == 27) quit();

 if (keyhit == 80)
  setmousestat(xc, yc+1);

 if (keyhit == 72)
  setmousestat(xc, yc-1);

 if (keyhit == 75)
  setmousestat(xc-1, yc);

 if (keyhit == 77)
  setmousestat(xc+1, yc);

 if (keyhit == 32)
	lb = 1;
 if (keyhit == 8)
	rb = 1;

  movedata(FP_SEG(screen1), FP_OFF(screen1), FP_SEG(screen3), FP_OFF(screen3), 8000);
  box(8, 25-3, 72, 25+3, 0, 2, 15, 9, FP_SEG(screen3), FP_OFF(screen3));
  print("[ SEE SET ]", -40, 25-3, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
  print("You must save current set to view it!", -40, 25, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
  print("           <OKAY>        ", 26, 25+2, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
  sprint(peekb(FP_SEG(screen3), FP_OFF(screen3) + (yc-1) * 160 + (xc-1) * 2), xc, yc, 0, 15, 0, FP_SEG(screen3), FP_OFF(screen3));
  movedata(FP_SEG(screen3), FP_OFF(screen3), 0xB800, 0, 8000);
  if (coords(37,27,42,27,1,0))
		break;
  }
 }
else
  {

  asm {
		 MOV AX, 3;
		 INT 0x10;
		}
 setfont(filename);
int x = 1;
int y = 1;
 for (int c = 0; c < 256; c++)
	{
	 sprint(c,x+32, y+4, 15, 0, 0,0xB800, 0);
	 x++;
	 if (x == 17) { x = 1; y++; }
	 }
delay(1000);
  for (; ;)
	{
	 mousestat();
	 if (lb == 1 || kbhit())
	  break;
	}
clrscr();
textmode(C4350);
togglebit(0);
delay(350);
 }
 }



if (which == 16)
 {
  unsigned char bits;
  int s, q;
  int ii, jj;

 for (q = 0; q < 256; q++)
 {
 if (!hasdata(q))
  {
  for (jj = 1; jj <= fontsize; jj++)
	for (ii = 1; ii <= 8; ii++)
	  table[q][ii][jj] = 0;

  for (s = 0; s <= fontsize-1; s++)
	{

    if (fontsize == 16)
      bits = peekb(FP_SEG(biosfont16), FP_OFF(biosfont16) + fontsize * q + s);
    if (fontsize == 14)
      bits = peekb(FP_SEG(biosfont14), FP_OFF(biosfont14) + fontsize * q + s);
    if (fontsize == 8)
      bits = peekb(FP_SEG(biosfont8), FP_OFF(biosfont8) + fontsize * q + s);

	 if (bits & 1) table[q][8][s+1] = 1;
	 if (bits & 2) table[q][7][s+1] = 1;
	 if (bits & 4) table[q][6][s+1] = 1;
	 if (bits & 8) table[q][5][s+1] = 1;
	 if (bits & 16) table[q][4][s+1] = 1;
	 if (bits & 32) table[q][3][s+1] = 1;
	 if (bits & 64) table[q][2][s+1] = 1;
	 if (bits & 128) table[q][1][s+1] = 1;
	}

  }
 }

 }






if (which == 17)
{
 for (k = 0; k < 26; k++)
   {
    for (i = 1; i <= 8; i++)
     for (j = 1; j <= fontsize; j++)
       table[97+k][i][j] = table[65+k][i][j];
   }
}

if (which == 18)
{
 for (k = 0; k < 26; k++)
   {
    for (i = 1; i <= 8; i++)
     for (j = 1; j <= fontsize; j++)
       table[65+k][i][j] = table[97+k][i][j];
   }            
}






}



int killfont()
 {
  for (; ;)
	 {
	  mousestat();
	  keyhit = 0;
	  if (kbhit())
		{
		 keyhit = getch();
		 clrkb();
		}
	  if (keyhit == 80)
		setmousestat(xc, yc+1);
	  if (keyhit == 72)
		setmousestat(xc, yc-1);
	  if (keyhit == 75)
		setmousestat(xc-1, yc);
	  if (keyhit == 77)
		setmousestat(xc+1, yc);
	  if (keyhit == 32)
		lb = 1;
	  if (keyhit == 8)
		rb = 1;
	  movedata(FP_SEG(screen1), FP_OFF(screen1), FP_SEG(screen3), FP_OFF(screen3), 8000);
	  box(8, 25-3, 72, 25+3, 0, 2, 15, 9, FP_SEG(screen3), FP_OFF(screen3));
	  print("[ CHANGES MADE ]", -40, 25-3, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
	  print("Are you sure you wish to destroy", -40, 25-1, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
	  print("   the font currently loaded?   ", -40, 25, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
     print("    <PROCEED>  <ABORT>   ", 26, 25+2, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
	  sprint(peekb(FP_SEG(screen3), FP_OFF(screen3) + (yc-1) * 160 + (xc-1) * 2), xc, yc, 0, 15, 0, FP_SEG(screen3), FP_OFF(screen3));
	  movedata(FP_SEG(screen3), FP_OFF(screen3), 0xB800, 0, 8000);
	  if (coords(30,27,38,27,1,0))
		{
		delay(150);
		return 1;
		}
	  if (coords(41,27,47,27,1,0))
		{
		delay(150);
		return 0;
		}
	  }

 }







void help()
{
char far *holder;
char filename[20];

strcpy(filename, "dosfedit.txt");
char holdit[191];
long int lines = 0;
unsigned long int counter = 0;
int ii;
int jj;
FILE *f;
f = fopen(filename, "r");

while (!feof(f))
{
fgets(holdit, 81, f);
lines++;
}
lines--;
fclose(f);

holder = (char far *) farmalloc(lines*60);


if (holder == NULL)
 {
 printf ("No mem");
 getch();
 exit(0);
 }


f = fopen(filename, "r");
while (!feof(f))
{
fgets(holdit, 81, f);
 for (ii = 0; ii < strlen(holdit); ii++)
	if (holdit[ii] == 10 || holdit[ii] == 13)
	  {
		for (jj = ii; jj <= 60; jj++)
		 holdit[jj] = 32;
		holdit[61] = '\0';
		break;
	  }
movedata(FP_SEG(holdit), FP_OFF(holdit), FP_SEG(holder), FP_OFF(holder) + (unsigned int)counter, 60);
counter = counter + 60;
}

fclose(f);

long int off = 0;
//unsigned char keys = 0;

for ( ; ; )
{
	  mousestat();
	  keyhit = 0;
	  if (kbhit())
		{
		 keyhit = getch();
		 clrkb();
		}
	  if (keyhit == 80)
		setmousestat(xc, yc+1);
	  if (keyhit == 72)
		setmousestat(xc, yc-1);
	  if (keyhit == 75)
		setmousestat(xc-1, yc);
	  if (keyhit == 77)
		setmousestat(xc+1, yc);
	  if (keyhit == 32)
		lb = 1;
	  if (keyhit == 8)
		rb = 1;




movedata(FP_SEG(screen2), FP_OFF(screen2), FP_SEG(screen3), FP_OFF(screen3), 8000);
box(9,11,73,42, 0, 0, 15, 1,FP_SEG(screen3), FP_OFF(screen3));

box(34,4,45,6, 1, 1, 15, 1,FP_SEG(screen3), FP_OFF(screen3));
print ("HELP FILE", -40, 5, 15, 1, 0,FP_SEG(screen3), FP_OFF(screen3));
print ("< BACK >", 1, 50, 15, 1, 0,FP_SEG(screen3), FP_OFF(screen3));


for (i = 1; i <= 30; i++)
 {
  if (off + i > lines) break;
  movedata(FP_SEG(holder), FP_OFF(holder) + (unsigned)((i+off-1)*60), FP_SEG(holdit), FP_OFF(holdit), 60);
  print(holdit, 10, i+11, 15, 1, 0,FP_SEG(screen3), FP_OFF(screen3));
 }

//print(off+1, 1, 24, 15, 0, 0,FP_SEG(screen3), FP_OFF(screen3));
//print(lines, 5, 24, 15, 0, 0,FP_SEG(screen3), FP_OFF(screen3));

  if (coords(71,41,1,0))
		  {
			off++;
			if (off > lines-30) off--;
		  }

  if (coords(71,12,1,0))
		  {
			off--;
			if (off < 0) off++;
		  }

  if (coords(71,39,1,0))
		  {
			off+=30;
			if (off > lines-30) off=lines-30;
		  }

  if (coords(71,14,1,0))
		  {
			off-=30;
			if (off < 0) off=0;
		  }

if (coords(1,50,8,50,1,0))
 break;


box(9,11,73,42, 1, -1, 15, 1,FP_SEG(screen3), FP_OFF(screen3));

sprint(24, 71, 12, 15, 1, 0,FP_SEG(screen3), FP_OFF(screen3));
sprint(25, 71, 41, 15, 1, 0,FP_SEG(screen3), FP_OFF(screen3));

sprint(24, 71, 14, 11, 1, 0,FP_SEG(screen3), FP_OFF(screen3));
sprint(25, 71, 39, 11, 1, 0,FP_SEG(screen3), FP_OFF(screen3));



sprint(peekb(FP_SEG(screen3), FP_OFF(screen3) + (yc-1) * 160 + (xc-1) * 2), xc, yc, 0, 15, 0, FP_SEG(screen3), FP_OFF(screen3));
movedata(FP_SEG(screen3), FP_OFF(screen3), 0xB800, 0, 8000);
}



farfree(holder);

}


void putbios()
{

unsigned short segs, off;

//BH = 3 for 8*8

asm {
     PUSH BP;
     MOV AH, 0x11;
     MOV AL, 0x30;
     MOV BH, 6;
     INT 0x10;
     MOV AX, BP;
     POP BP;
     MOV off, AX;
     MOV segs, ES;
    }
movedata(segs, off, FP_SEG(biosfont16), FP_OFF(biosfont16), 4096);

asm {
     PUSH BP;
     MOV AH, 0x11;
     MOV AL, 0x30;
     MOV BH, 2;
     INT 0x10;
     MOV AX, BP;
     POP BP;
     MOV off, AX;
     MOV segs, ES;
    }
movedata(segs, off, FP_SEG(biosfont14), FP_OFF(biosfont14), 14*256);

asm {
     PUSH BP;
     MOV AH, 0x11;
     MOV AL, 0x30;
     MOV BH, 3;
     INT 0x10;
     MOV AX, BP;
     POP BP;
     MOV off, AX;
     MOV segs, ES;
    }
movedata(segs, off, FP_SEG(biosfont8), FP_OFF(biosfont8), 8*128);

asm {
     PUSH BP;
     MOV AH, 0x11;
     MOV AL, 0x30;
     MOV BH, 0;
     INT 0x10;
     MOV AX, BP;
     POP BP;
     MOV off, AX;
     MOV segs, ES;
    }
movedata(segs, off, FP_SEG(biosfont8), FP_OFF(biosfont8)+8*128, 8*128);

}


int hasdata(int character)
 {
  int check = 0;
  for (int aa = 1; aa <= 8; aa++)
   for (int bb = 1; bb <= 16; bb++)
     if (table[character][aa][bb] == 1)
        check = 1;
  if (check == 1) return 1;
  return 0;
 }


int hurtfont()
 {
  for (; ;)
	 {
	  mousestat();
	  keyhit = 0;
	  if (kbhit())
		{
		 keyhit = getch();
		 clrkb();
		}
	  if (keyhit == 80)
		setmousestat(xc, yc+1);
	  if (keyhit == 72)
		setmousestat(xc, yc-1);
	  if (keyhit == 75)
		setmousestat(xc-1, yc);
	  if (keyhit == 77)
		setmousestat(xc+1, yc);
	  if (keyhit == 32)
		lb = 1;
	  if (keyhit == 8)
		rb = 1;
	  movedata(FP_SEG(screen1), FP_OFF(screen1), FP_SEG(screen3), FP_OFF(screen3), 8000);
	  box(8, 25-3, 72, 25+3, 0, 2, 15, 9, FP_SEG(screen3), FP_OFF(screen3));
	  print("[ WARNING ]", -40, 25-3, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
	  print("This action will change the font", -40, 25-1, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
	  print("signifigantly.", -40, 25, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
     print("    <PROCEED>  <ABORT>   ", 26, 25+2, 15, 9, 0,FP_SEG(screen3), FP_OFF(screen3));
	  sprint(peekb(FP_SEG(screen3), FP_OFF(screen3) + (yc-1) * 160 + (xc-1) * 2), xc, yc, 0, 15, 0, FP_SEG(screen3), FP_OFF(screen3));
	  movedata(FP_SEG(screen3), FP_OFF(screen3), 0xB800, 0, 8000);
	  if (coords(30,27,38,27,1,0))
		{
		delay(150);
		return 1;
		}
	  if (coords(41,27,47,27,1,0))
		{
		delay(150);
		return 0;
		}
	  }

 }

